/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 17/01/2018
 --------------------------------------------------------
*/
package com.portofolio.service;


import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.MapRuanganLoginToRuanganPDao;
import com.portofolio.dao.RuanganDao;
import com.portofolio.dto.KodeStringDto;
import com.portofolio.dto.MapRuanganLoginToRuanganPDto;
import com.portofolio.entity.MapRuanganLoginToRuanganP;
import com.portofolio.entity.Ruangan;
import com.portofolio.entity.vo.MapRuanganLoginToRuanganPId;
import com.portofolio.util.CommonUtil;

@Lazy
@Service
public class MapRuanganLoginToRuanganPService extends BaseServiceImpl {
	@Lazy
	@Autowired
	private MapRuanganLoginToRuanganPDao mapRuanganLoginToRuanganPelayananDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private RuanganDao ruanganDao;
	

	@Transactional
	public Map<String, Object> update(MapRuanganLoginToRuanganPDto dto) {
		result.clear();
		List<Map<String, Object>> results = CommonUtil.createList();


		mapRuanganLoginToRuanganPelayananDao.setStatusEnabledFalse(getKdProfile(), dto.getKdRuanganLogin(),dto.getEnumJenisMaping(),dto.getEnumKelompokTransaksi());
		for (KodeStringDto kdRuanganPelayanan : dto.getKdRuanganPelayanan()) {
			
			Map<String, Object> tmp = CommonUtil.createMap();
			
			MapRuanganLoginToRuanganPId id = new MapRuanganLoginToRuanganPId();
			id.setKdRuanganPelayanan(kdRuanganPelayanan.getKode());
			id.setKdRuanganLogin(dto.getKdRuanganLogin());
			id.setEnumKelompokTransaksi(dto.getEnumKelompokTransaksi());
			id.setKdProfile(getKdProfile());
			id.setEnumJenisMaping(dto.getEnumJenisMaping());
			MapRuanganLoginToRuanganP mapLoginUserToRuanganP = CommonUtil.findOne(mapRuanganLoginToRuanganPelayananDao, id);
			if (CommonUtil.isNotNullOrEmpty(mapLoginUserToRuanganP)) {
				mapLoginUserToRuanganP.setStatusEnabled(true);
			} else {
				mapLoginUserToRuanganP = new MapRuanganLoginToRuanganP();
				mapLoginUserToRuanganP.setId(id);
				mapLoginUserToRuanganP.setStatusEnabled(true);
				mapLoginUserToRuanganP.setNoRec(generateUuid32());
				mapLoginUserToRuanganP.setVersion(1);
			}
			
			mapLoginUserToRuanganP = mapRuanganLoginToRuanganPelayananDao.save(mapLoginUserToRuanganP);
			tmp.put("mapRuanganLoginToRuanganPId", mapLoginUserToRuanganP.getId());
			results.add(tmp);

		}
		result.put("data", results);
		resultUpdated();
		return result;
	}
	
	public Map<String, Object> findAllAksesByKdRuanganLogin(String kdRuanganLogin,Integer enumJenisMaping,Integer enumKelompokTransaksi) {
		result.clear();
		
		List<MapRuanganLoginToRuanganP> findByIdKdProfileAndKdRuanganLoginAndEnumJenisMapingAndEnumKelompokTransaksi = CommonUtil.createList();
		findByIdKdProfileAndKdRuanganLoginAndEnumJenisMapingAndEnumKelompokTransaksi = mapRuanganLoginToRuanganPelayananDao.findObjekRuanganLoginToRuanganPelayananByPrimary(getKdProfile(), kdRuanganLogin,enumJenisMaping,enumKelompokTransaksi);

		List<Ruangan> ruanganPelayanans = ruanganDao.findAllRuanganHeadIsNotNull(getKdProfile());
		List<Map<String, Object>> tmpMapRuanganPelayanan = CommonUtil.createList();
		for (Ruangan map : ruanganPelayanans) {
			Map<String, Object> mapRuanganPelayanan = CommonUtil.createMap();
			mapRuanganPelayanan.put("kdRuanganPelayanan", map.getId().getKdRuangan());
			mapRuanganPelayanan.put("namaRuanganPelayanan", map.getNamaRuangan());
			mapRuanganPelayanan.put("statusEnabled", false);
			for (MapRuanganLoginToRuanganP map2 : findByIdKdProfileAndKdRuanganLoginAndEnumJenisMapingAndEnumKelompokTransaksi) {
				if (map2.getId().getKdRuanganPelayanan().equals(map.getId().getKdRuangan())) {
					if(map2.getStatusEnabled()) {
						mapRuanganPelayanan.replace("statusEnabled", true);
					}
					
				}
			}
			tmpMapRuanganPelayanan.add(mapRuanganPelayanan);
		}
		result.put("ruanganPelayanan", tmpMapRuanganPelayanan);
		resultSuccessful();
		return result;
	}

	public Map<String, Object> findMapRuanganLoginToRuanganPelayananByPrimary(String kdRuanganLogin,Integer enumJenisMaping,Integer enumKelompokTransaksi,String namaRuanganPelayanan) {
		result.clear();
		List<Map<String,Object>> list = CommonUtil.createList();
		if(CommonUtil.isNullOrEmpty(namaRuanganPelayanan)) {
			//Tidak ada parameter namaRuanganPelayanan
			list = mapRuanganLoginToRuanganPelayananDao.findMapRuanganLoginToRuanganPelayananByPrimary(getKdProfile(), kdRuanganLogin,enumJenisMaping,enumKelompokTransaksi);
		}else {
			//Ada parameter namaRuanganPelayanan
			list = mapRuanganLoginToRuanganPelayananDao.findMapRuanganLoginToRuanganPelayananByPrimary(getKdProfile(), kdRuanganLogin,enumJenisMaping,enumKelompokTransaksi,namaRuanganPelayanan);
		}
		result.put("ruanganPelayanan", list);
		resultSuccessful();
		return result;
	}
	
	public List<String> findKdRuanganPelayananByPrimary(String kdRuanganLogin,Integer enumJenisMaping,Integer enumKelompokTransaksi) {
		List<String> kdRuanganPelayanan= mapRuanganLoginToRuanganPelayananDao.findKdRuanganPelayananByPrimary(getKdProfile(), kdRuanganLogin, enumJenisMaping, enumKelompokTransaksi);
		if(CommonUtil.isNullOrEmpty(kdRuanganPelayanan)) {
			kdRuanganPelayanan.add("-");
		}
		return kdRuanganPelayanan;
	}
	

}
